using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;
using Interop = System.Runtime.InteropServices;

namespace DocPreview
{

	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
    [DllImport("Gdi32.dll")]
    public static extern int DeleteObject(IntPtr hObject);

    //---------------------------------
    // Doc Preview Variables
    //---------------------------------
    VISSHELib.ImageExtractorShellExtClass  m_IImageExtractorShellExt;
    Interop.UCOMIPersistFile               m_IPersistFile;
    olelib.IExtractImage                   m_IExtractImage;
    String                                 m_FilePath;
    String                                 m_HomeDir;

    //---------------------------------
    private void Form1_Load(object sender, System.EventArgs e) {
    //---------------------------------
      string S = Application.ExecutablePath;
      m_HomeDir                 = Path.GetDirectoryName(S);      
      openFileDialog1.InitialDirectory = m_HomeDir;

      m_IImageExtractorShellExt =  new VISSHELib.ImageExtractorShellExtClass();
      m_IPersistFile            = (Interop.UCOMIPersistFile) m_IImageExtractorShellExt;
      m_IExtractImage           = (olelib.IExtractImage)     m_IImageExtractorShellExt;        
    }

    private System.Windows.Forms.Panel panel1;
    private System.Windows.Forms.Button bt_LoadPreview;
    private System.Windows.Forms.Panel panel2;
    private System.Windows.Forms.PictureBox pictureBox1;
    private System.Windows.Forms.Label label1;
    private System.Windows.Forms.OpenFileDialog openFileDialog1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.panel1 = new System.Windows.Forms.Panel();
      this.label1 = new System.Windows.Forms.Label();
      this.bt_LoadPreview = new System.Windows.Forms.Button();
      this.panel2 = new System.Windows.Forms.Panel();
      this.pictureBox1 = new System.Windows.Forms.PictureBox();
      this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
      this.panel1.SuspendLayout();
      this.panel2.SuspendLayout();
      this.SuspendLayout();
      // 
      // panel1
      // 
      this.panel1.Controls.Add(this.label1);
      this.panel1.Controls.Add(this.bt_LoadPreview);
      this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
      this.panel1.Location = new System.Drawing.Point(0, 0);
      this.panel1.Name = "panel1";
      this.panel1.Size = new System.Drawing.Size(376, 48);
      this.panel1.TabIndex = 0;
      // 
      // label1
      // 
      this.label1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right)));
      this.label1.Location = new System.Drawing.Point(80, 8);
      this.label1.Name = "label1";
      this.label1.Size = new System.Drawing.Size(280, 32);
      this.label1.TabIndex = 1;
      this.label1.Text = "label1";
      // 
      // bt_LoadPreview
      // 
      this.bt_LoadPreview.Location = new System.Drawing.Point(8, 8);
      this.bt_LoadPreview.Name = "bt_LoadPreview";
      this.bt_LoadPreview.Size = new System.Drawing.Size(64, 32);
      this.bt_LoadPreview.TabIndex = 0;
      this.bt_LoadPreview.Text = "Load Preview";
      this.bt_LoadPreview.Click += new System.EventHandler(this.bt_LoadPreview_Click);
      // 
      // panel2
      // 
      this.panel2.Controls.Add(this.pictureBox1);
      this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
      this.panel2.Location = new System.Drawing.Point(0, 48);
      this.panel2.Name = "panel2";
      this.panel2.Size = new System.Drawing.Size(376, 331);
      this.panel2.TabIndex = 1;
      // 
      // pictureBox1
      // 
      this.pictureBox1.Dock = System.Windows.Forms.DockStyle.Fill;
      this.pictureBox1.Location = new System.Drawing.Point(0, 0);
      this.pictureBox1.Name = "pictureBox1";
      this.pictureBox1.Size = new System.Drawing.Size(376, 331);
      this.pictureBox1.TabIndex = 0;
      this.pictureBox1.TabStop = false;
      // 
      // openFileDialog1
      // 
      this.openFileDialog1.DefaultExt = "vsd";
      this.openFileDialog1.Filter = "Visio files *.vsd|*.vsd|All files *.*|*.*";
      // 
      // Form1
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(376, 379);
      this.Controls.Add(this.panel2);
      this.Controls.Add(this.panel1);
      this.Name = "Form1";
      this.Text = "Visio Preview Viewer";
      this.Resize += new System.EventHandler(this.Form1_Resize);
      this.Load += new System.EventHandler(this.Form1_Load);
      this.panel1.ResumeLayout(false);
      this.panel2.ResumeLayout(false);
      this.ResumeLayout(false);

    }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		/// 

		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

    //---------------------------------
    private void bt_LoadPreview_Click(object sender, System.EventArgs e) {
    //---------------------------------
      m_FilePath = "F:\\Proj_V11DSP\\_DistribPrep\\CSharp\\vy3540u_DocsPagesLayers\\DocPreview\\PreviewPicTest.vsd";
     
      if(openFileDialog1.ShowDialog() == DialogResult.OK) {
        m_FilePath = openFileDialog1.FileName;
        label1.Text = m_FilePath;
        ReloadPreview();
      }
    }

    //---------------------------------
    private void ReloadPreview() {
    //---------------------------------
      pictureBox1.Image = null;
      if (File.Exists(m_FilePath) ) {
        try {
          m_IPersistFile.Load(m_FilePath, 0);
          olelib.IEIFlags Flags    = 0;
          int             DummyInt = 0;
          olelib.SIZE     ASize;
          ASize.cx  = pictureBox1.Width;
          ASize.cy  = pictureBox1.Height;
          m_IExtractImage.GetLocation(0, 0,ref DummyInt, ref ASize, 16, ref Flags);

          IntPtr MyHBitmap = (IntPtr) m_IExtractImage.Extract();
          Bitmap bmp       = Image.FromHbitmap(MyHBitmap); 
          DeleteObject(MyHBitmap);
          pictureBox1.Image = bmp;
        } catch  {
        }
      }
    }

    //---------------------------------
    private void Form1_Resize(object sender, System.EventArgs e) {
    //---------------------------------
      ReloadPreview();
    }
	}
}
