VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1095
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3600
   LinkTopic       =   "Form1"
   ScaleHeight     =   1095
   ScaleWidth      =   3600
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton bt_Generate 
      Caption         =   "Generate vdx"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1275
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const DirPath = ""
Const InFileName = "BlankOrg.vdx"
Const OutFileName = "Org_out.vdx"
Const VisioNS = "urn:schemas-microsoft-com:office:visio"

'------------------------------------
Private Sub bt_Generate_Click()
'------------------------------------
Dim Doc As MSXML2.DOMDocument30
Dim Shapes As MSXML2.IXMLDOMElement
Dim Connects As MSXML2.IXMLDOMElement
Dim N As Integer

  Set Doc = New MSXML2.DOMDocument30
  Doc.Load DirPath + InFileName
  
  Set Shapes = Doc.documentElement.selectSingleNode( _
    "/VisioDocument/Pages/Page/Shapes")
  Set Connects = Doc.documentElement.selectSingleNode( _
    "/VisioDocument/Pages/Page/Connects")
  
  '----------------------------------------
  ' Delete sample shapes
  '----------------------------------------
  For N = Shapes.childNodes.length - 1 To 0 Step -1
    Shapes.removeChild Shapes.childNodes.Item(N)
  Next N
  
  '----------------------------------------
  ' Add new Orgs
  '----------------------------------------
  PlaceOrg Doc, Shapes, 10, 4#, 9#, "HQ"
  PlaceOrg Doc, Shapes, 11, 2#, 7#, "Dept A"
  PlaceOrg Doc, Shapes, 12, 6#, 7#, "Dept B"
  
  '----------------------------------------
  ' Delete sample connects
  '----------------------------------------
  For N = Connects.childNodes.length - 1 To 0 Step -1
    Connects.removeChild Connects.childNodes.Item(N)
  Next N
  
  '----------------------------------------
  ' Add connections
  '----------------------------------------
  ConnectOrgs Doc, Shapes, Connects, 20, 10, 11
  ConnectOrgs Doc, Shapes, Connects, 21, 10, 12
    
  Doc.save DirPath + OutFileName
End Sub

'------------------------------------
Private Sub PlaceOrg( _
  Doc As MSXML2.DOMDocument30, Shapes As MSXML2.IXMLDOMElement, _
  ID As Integer, X As Single, Y As Single, T As String)
'------------------------------------
Dim Shape As MSXML2.IXMLDOMElement
Dim Prop1 As MSXML2.IXMLDOMElement

  Set Shape = Doc.createNode(NODE_ELEMENT, "Shape", VisioNS)
  Shapes.appendChild Shape
  Shape.setAttribute "ID", Format(ID)
  Shape.setAttribute "Type", "Shape"
  Shape.setAttribute "NameU", "Org"
  Shape.setAttribute "Master", "0"
  
  Set Prop1 = AddProp(Doc, Shape, "XForm", "")
  AddProp Doc, Prop1, "PinX", Format(X)
  AddProp Doc, Prop1, "PinY", Format(Y)
  
  AddProp Doc, Shape, "Text", T
End Sub

'------------------------------------
Private Function AddProp( _
  Doc As MSXML2.DOMDocument30, Parent As MSXML2.IXMLDOMElement, _
  PropName As String, PropText As String) As MSXML2.IXMLDOMElement
'------------------------------------
Dim TempProp As MSXML2.IXMLDOMElement

  ' Set TempProp = Doc.createElement(PropName)
  Set TempProp = Doc.createNode(NODE_ELEMENT, PropName, VisioNS)
  Parent.appendChild TempProp
  TempProp.Text = PropText
  Set AddProp = TempProp
End Function
         
'------------------------------------
Private Sub ConnectOrgs( _
  Doc As MSXML2.DOMDocument30, Shapes As MSXML2.IXMLDOMElement, _
  Connects As MSXML2.IXMLDOMElement, _
  ConnID As Integer, ParentID As Integer, ChildID As Integer)
'------------------------------------
Dim Shape As MSXML2.IXMLDOMElement
Dim Connect As MSXML2.IXMLDOMElement
Dim Prop1 As MSXML2.IXMLDOMElement

  Set Shape = Doc.createNode(NODE_ELEMENT, "Shape", VisioNS)
  Shapes.appendChild Shape
  Shape.setAttribute "ID", Format(ConnID)
  Shape.setAttribute "Type", "Shape"
  Shape.setAttribute "NameU", "Conn"
  Shape.setAttribute "Master", "1"
  
  ' Begin end of connector
  Set Connect = Doc.createNode(NODE_ELEMENT, "Connect", VisioNS)
  Connects.appendChild Connect
  Connect.setAttribute "FromSheet", Format(ConnID)
  Connect.setAttribute "FromCell", "BeginX"
  Connect.setAttribute "ToSheet", Format(ChildID)
  Connect.setAttribute "ToCell", "Connections.X1"
  
  ' End end of connector
  Set Connect = Doc.createNode(NODE_ELEMENT, "Connect", VisioNS)
  Connects.appendChild Connect
  Connect.setAttribute "FromSheet", Format(ConnID)
  Connect.setAttribute "FromCell", "EndX"
  Connect.setAttribute "ToSheet", Format(ParentID)
  Connect.setAttribute "ToCell", "Connections.X2"
End Sub


