VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4785
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5610
   LinkTopic       =   "Form1"
   ScaleHeight     =   4785
   ScaleWidth      =   5610
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton bt_ReportShapes 
      Caption         =   "Report Shapes"
      Height          =   555
      Left            =   3840
      TabIndex        =   4
      Top             =   60
      Width           =   1095
   End
   Begin VB.CommandButton bt_FindNodesXPath 
      Caption         =   "Find Nodes XPath"
      Height          =   555
      Left            =   2640
      TabIndex        =   3
      Top             =   60
      Width           =   1095
   End
   Begin VB.CommandButton bt_FindNodesXSLPatterns 
      Caption         =   "Find Nodes XSLPatterns"
      Height          =   555
      Left            =   1380
      TabIndex        =   2
      Top             =   60
      Width           =   1095
   End
   Begin VB.CommandButton bt_DocTree 
      Caption         =   "Document Tree"
      Height          =   555
      Left            =   120
      TabIndex        =   1
      Top             =   60
      Width           =   1155
   End
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3915
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Text            =   "msxmltest_Form1.frx":0000
      Top             =   720
      Width           =   4635
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const DirPath = ""
Const InFileName = "MyBasicDoc.vdx"
Const OutFileName = "MyBasicDoc_out.vdx"
Const XSLFileName = "MyBasicDocXSL.xsl"
Const HtmFileName = "MyBasicDoc_Report.htm"
Dim OutputLines As String

'---------------------------------
Private Sub bt_DocTree_Click()
'---------------------------------
Dim Doc As MSXML2.DOMDocument30

  Set Doc = New MSXML2.DOMDocument30
  Doc.Load DirPath + InFileName
  
  Text1.Text = ""
  OutputLines = ""
  
  ProcessNode Doc.documentElement, 0
    
  Text1.Text = OutputLines
  ' Doc.save DirPath + OutFileName
End Sub

'---------------------------------
Private Sub ProcessNode(Node As MSXML2.IXMLDOMNode, Depth As Integer)
'---------------------------------
Dim NewNode As MSXML2.IXMLDOMNode
Dim NodeEl As MSXML2.IXMLDOMElement
Dim NodeTx As MSXML2.IXMLDOMText
Dim Attrib As MSXML2.IXMLDOMAttribute
Dim N As Integer, NodeType As Long, S As String, AN As Integer
Dim AttribNodeName As String, AttribNodeValue As String

  Set NodeEl = Nothing
  Set NodeTx = Nothing
  Set Attrib = Nothing
   
  NodeType = Node.NodeType
  S = Format(Node.NodeType)
  Select Case NodeType
    Case NODE_ELEMENT
      Set NodeEl = Node
      S = "Element: " + NodeEl.tagName
    Case NODE_TEXT
      Set NodeTx = Node
      S = "Text: " + Left$(NodeTx.Text, 40)
  End Select
  S = Space(Depth * 2) + S
  OutputLines = OutputLines + S + vbCrLf
  ' Debug.Print S
    
  '--------------------------
  ' Attributes
  '--------------------------
  If Not (NodeEl Is Nothing) Then
    For AN = 0 To NodeEl.Attributes.length - 1
      Set Attrib = NodeEl.Attributes.Item(AN)
      AttribNodeName = Attrib.nodeName
      AttribNodeValue = Attrib.nodeValue
      S = "Attrib: " + AttribNodeName + " = " + AttribNodeValue
      S = Space((Depth + 1) * 2) + S
      OutputLines = OutputLines + S + vbCrLf
      ' Debug.Print S
      If (AttribNodeName = "Master") And (AttribNodeValue = "0") Then
        Attrib.nodeValue = "2"
      End If
    Next AN
  End If
    
  '--------------------------
  ' Child Nodes
  '--------------------------
  For N = 0 To Node.childNodes.length - 1
    ProcessNode Node.childNodes(N), Depth + 1
  Next N
End Sub

'---------------------------------
Private Sub Form_Resize()
'---------------------------------
  Text1.Left = Me.ScaleLeft
  Text1.Width = Me.ScaleWidth - Text1.Left
  Text1.Height = Me.ScaleHeight - Text1.Top
End Sub

'---------------------------------
Private Sub bt_FindNodesXSLPatterns_Click()
'---------------------------------
Dim Doc As MSXML2.DOMDocument30
Dim Sel As MSXML2.IXMLDOMNode

  Text1.Text = ""
  OutputLines = ""
  
  Set Doc = New MSXML2.DOMDocument30
  Doc.Load DirPath + InFileName
  
  Set Sel = Doc.documentElement.selectSingleNode("/VisioDocument/Pages/Page/Shapes")
  
  ProcessNode Sel, 0
    
  Text1.Text = OutputLines
End Sub

'---------------------------------
Private Sub bt_FindNodesXPath_Click()
'---------------------------------
Dim Doc As MSXML2.DOMDocument30
Dim Sel As MSXML2.IXMLDOMNode

  Text1.Text = ""
  OutputLines = ""
  
  Set Doc = New MSXML2.DOMDocument30
  Doc.Load DirPath + InFileName
  
  Doc.setProperty "SelectionLanguage", "XPath"
  Doc.setProperty "SelectionNamespaces", "xmlns:ns='urn:schemas-microsoft-com:office:visio'"
  Set Sel = Doc.documentElement.selectSingleNode("/descendant::ns:Page/ns:Shapes")
  
  ProcessNode Sel, 0
  
  Text1.Text = OutputLines
End Sub

'---------------------------------
Private Sub bt_ReportShapes_Click()
'---------------------------------
Dim VDXDoc As New MSXML2.DOMDocument30
Dim XSLDoc As New MSXML2.DOMDocument30
Dim ResultStr As String, OutFileName As String

  VDXDoc.Load DirPath + InFileName
  XSLDoc.Load DirPath + XSLFileName
  ResultStr = VDXDoc.transformNode(XSLDoc.documentElement)
  Debug.Print ResultStr
  OutFileName = DirPath + HtmFileName
  Open OutFileName For Output As #1
  Print #1, ResultStr
  Close #1
End Sub
